Unit QSR2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSR2R(var RINT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var IERR :Integer);

implementation

procedure QSR2R(var RINT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var IERR :Integer);
var
I,J,M,N :Integer;
D,H,S :Real;
T :Array [0..20] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
IERR := 0;
D := B - A;
T[0] := (F(A) + F(B))/2.0;
N := 1;
_10:
for I:=1 to 20 do
 begin
  S := 0.0;
  N := 2*N;
  H := D/N;
  J := 1;
  while ( J<=N ) do
   begin
    S := S + F(A+J*H);
_20:
    inc(J,2);
   end;
  T[I+0] := (2.0*S/N + T[I-1])/2.0;
  M := 1;
  J := I;
_30:
  M := 4*M;
  T[J-1] := T[J+0] + (T[J+0] - T[J-1])/(M - 1);
  J := J - 1;
  if ( J - 1 ) < 0
   then goto _40
   else if ( J - 1 ) > 0
         then goto _30
         else goto _30;
_40:
  if ( I - 3 ) < 0
   then goto _60
   else if ( I - 3 ) > 0
         then goto _50
         else goto _50;
_50:
  if ( Abs(T[0] - T[1]) - E ) < 0
   then goto _90
   else if ( Abs(T[0] - T[1]) - E ) > 0
         then goto _60
         else goto _90;
_60:
  if ( I  >=  20 ) 
   then goto _80;
_70:
 end;
_80:
IERR := 65;
UTQS11(IERR,12);
goto _100;
_90:
RINT := T[0]*D;
_100:
end;

end.
